<html>
<head>
<title>OGRE: OgreSharedPtr.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSharedPtr.h</h1><a href="OgreSharedPtr_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __SharedPtr_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __SharedPtr_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 
<a name="l00044"></a><a class="code" href="classOgre_1_1SharedPtr.html">00044</a>     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a> {
<a name="l00045"></a>00045     <span class="keyword">protected</span>:
<a name="l00046"></a><a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">00046</a>         T* <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>;
<a name="l00047"></a><a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">00047</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>;
<a name="l00048"></a>00048     <span class="keyword">public</span>:
<a name="l00049"></a>00049         <a class="code" href="OgrePrerequisites_8h.html#b0e8c6d123555d7447c38185a1b9105e">OGRE_AUTO_SHARED_MUTEX</a> <span class="comment">// public to allow external locking</span>
<a name="l00054"></a><a class="code" href="classOgre_1_1SharedPtr.html#e46c7b984c057d18d8bd169cf2a60fad">00054</a> <span class="comment"></span>        <a class="code" href="classOgre_1_1SharedPtr.html#e46c7b984c057d18d8bd169cf2a60fad" title="Constructor, does not initialise the SharedPtr.">SharedPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>(0), <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>(0)
<a name="l00055"></a>00055         {
<a name="l00056"></a>00056             <a class="code" href="OgrePrerequisites_8h.html#053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00057"></a>00057         }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059         <span class="keyword">template</span>&lt; <span class="keyword">class</span> Y&gt;
<a name="l00060"></a><a class="code" href="classOgre_1_1SharedPtr.html#1217e645242e7b8ce87272239dab0b7f">00060</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1SharedPtr.html#e46c7b984c057d18d8bd169cf2a60fad" title="Constructor, does not initialise the SharedPtr.">SharedPtr</a>(Y* rep) : <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>(rep), <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>(new unsigned int(1))
<a name="l00061"></a>00061         {
<a name="l00062"></a>00062             <a class="code" href="OgrePrerequisites_8h.html#053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00063"></a>00063             <a class="code" href="OgrePrerequisites_8h.html#9ea1b6f845efd15c581b914ac84b93a3">OGRE_NEW_AUTO_SHARED_MUTEX</a>
<a name="l00064"></a>00064         }
<a name="l00065"></a><a class="code" href="classOgre_1_1SharedPtr.html#b1fae2b13ec9cb470b4616c56cb599d8">00065</a>         <a class="code" href="classOgre_1_1SharedPtr.html#e46c7b984c057d18d8bd169cf2a60fad" title="Constructor, does not initialise the SharedPtr.">SharedPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&amp; r)
<a name="l00066"></a>00066             : <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>(0), <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>(0)
<a name="l00067"></a>00067         {
<a name="l00068"></a>00068             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00069"></a>00069             
<a name="l00070"></a>00070             <a class="code" href="OgrePrerequisites_8h.html#053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00071"></a>00071             <a class="code" href="OgrePrerequisites_8h.html#2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00072"></a>00072             {
<a name="l00073"></a>00073                 <a class="code" href="OgrePrerequisites_8h.html#8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00074"></a>00074                 <a class="code" href="OgrePrerequisites_8h.html#cf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00075"></a>00075                 <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>;
<a name="l00076"></a>00076                 <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>; 
<a name="l00077"></a>00077                 <span class="comment">// Handle zero pointer gracefully to manage STL containers</span>
<a name="l00078"></a>00078                 <span class="keywordflow">if</span>(<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>)
<a name="l00079"></a>00079                 {
<a name="l00080"></a>00080                     ++(*pUseCount); 
<a name="l00081"></a>00081                 }
<a name="l00082"></a>00082             }
<a name="l00083"></a>00083         }
<a name="l00084"></a><a class="code" href="classOgre_1_1SharedPtr.html#1ce00b90526a205ae31268a88bc9ed35">00084</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&amp; <a class="code" href="classOgre_1_1SharedPtr.html#1ce00b90526a205ae31268a88bc9ed35">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&amp; r) {
<a name="l00085"></a>00085             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a> == r.<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>)
<a name="l00086"></a>00086                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00087"></a>00087             <span class="comment">// Swap current data into a local copy</span>
<a name="l00088"></a>00088             <span class="comment">// this ensures we deal with rhs and this being dependent</span>
<a name="l00089"></a>00089             <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;T&gt;</a> tmp(r);
<a name="l00090"></a>00090             <a class="code" href="classOgre_1_1SharedPtr.html#f07cad7e719e517472410d87f4e974ea">swap</a>(tmp);
<a name="l00091"></a>00091             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00092"></a>00092         }
<a name="l00093"></a>00093         
<a name="l00094"></a>00094         <span class="keyword">template</span>&lt; <span class="keyword">class</span> Y&gt;
<a name="l00095"></a><a class="code" href="classOgre_1_1SharedPtr.html#bebfecb1cfe727152e158bc73df81b97">00095</a>         <a class="code" href="classOgre_1_1SharedPtr.html#e46c7b984c057d18d8bd169cf2a60fad" title="Constructor, does not initialise the SharedPtr.">SharedPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;Y&gt;</a>&amp; r)
<a name="l00096"></a>00096             : <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>(0), <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>(0)
<a name="l00097"></a>00097         {
<a name="l00098"></a>00098             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100             <a class="code" href="OgrePrerequisites_8h.html#053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00101"></a>00101             <a class="code" href="OgrePrerequisites_8h.html#2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00102"></a>00102             {
<a name="l00103"></a>00103                 <a class="code" href="OgrePrerequisites_8h.html#8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00104"></a>00104                 <a class="code" href="OgrePrerequisites_8h.html#cf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00105"></a>00105                 <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#15e055008751a7c20bdde38662d5f0a1">getPointer</a>();
<a name="l00106"></a>00106                 <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00107"></a>00107                 <span class="comment">// Handle zero pointer gracefully to manage STL containers</span>
<a name="l00108"></a>00108                 <span class="keywordflow">if</span>(<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>)
<a name="l00109"></a>00109                 {
<a name="l00110"></a>00110                     ++(*pUseCount);
<a name="l00111"></a>00111                 }
<a name="l00112"></a>00112             }
<a name="l00113"></a>00113         }
<a name="l00114"></a>00114         <span class="keyword">template</span>&lt; <span class="keyword">class</span> Y&gt;
<a name="l00115"></a><a class="code" href="classOgre_1_1SharedPtr.html#fa22d1337c2afbd03d76b718e7b57d03">00115</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&amp; <a class="code" href="classOgre_1_1SharedPtr.html#1ce00b90526a205ae31268a88bc9ed35">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;Y&gt;</a>&amp; r) {
<a name="l00116"></a>00116             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a> == r.<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>)
<a name="l00117"></a>00117                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00118"></a>00118             <span class="comment">// Swap current data into a local copy</span>
<a name="l00119"></a>00119             <span class="comment">// this ensures we deal with rhs and this being dependent</span>
<a name="l00120"></a>00120             <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;T&gt;</a> tmp(r);
<a name="l00121"></a>00121             <a class="code" href="classOgre_1_1SharedPtr.html#f07cad7e719e517472410d87f4e974ea">swap</a>(tmp);
<a name="l00122"></a>00122             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00123"></a>00123         }
<a name="l00124"></a><a class="code" href="classOgre_1_1SharedPtr.html#3677e6904cd453e75b9b352ffe32f99d">00124</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html#3677e6904cd453e75b9b352ffe32f99d">~SharedPtr</a>() {
<a name="l00125"></a>00125             <a class="code" href="classOgre_1_1SharedPtr.html#a9225d4dac90501b6a5f0b2b49ea2eed">release</a>();
<a name="l00126"></a>00126         }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classOgre_1_1SharedPtr.html#8ea458552899a134e19e8fe69e03453a">00129</a>         <span class="keyword">inline</span> T&amp; <a class="code" href="classOgre_1_1SharedPtr.html#8ea458552899a134e19e8fe69e03453a">operator*</a>()<span class="keyword"> const </span>{ assert(<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>); <span class="keywordflow">return</span> *<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>; }
<a name="l00130"></a><a class="code" href="classOgre_1_1SharedPtr.html#756cec152c2db605fe7424da7f8e879b">00130</a>         <span class="keyword">inline</span> T* <a class="code" href="classOgre_1_1SharedPtr.html#756cec152c2db605fe7424da7f8e879b">operator-&gt;</a>()<span class="keyword"> const </span>{ assert(<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>); <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>; }
<a name="l00131"></a><a class="code" href="classOgre_1_1SharedPtr.html#2c3ed4a7b5574c4e53adec450fd537b0">00131</a>         <span class="keyword">inline</span> T* <span class="keyword">get</span>() <span class="keyword">const</span> { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>; }
<a name="l00132"></a>00132 
<a name="l00137"></a><a class="code" href="classOgre_1_1SharedPtr.html#1b5e6d7a4cc4f7b96e9aa56ccdc982aa">00137</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#1b5e6d7a4cc4f7b96e9aa56ccdc982aa" title="Binds rep to the SharedPtr.">bind</a>(T* rep) {
<a name="l00138"></a>00138             assert(!<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a> &amp;&amp; !<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>);
<a name="l00139"></a>00139             <a class="code" href="OgrePrerequisites_8h.html#9ea1b6f845efd15c581b914ac84b93a3">OGRE_NEW_AUTO_SHARED_MUTEX</a>
<a name="l00140"></a>00140             <a class="code" href="OgrePrerequisites_8h.html#062b6df8793a5440c06a9056ff1c8fe9">OGRE_LOCK_AUTO_SHARED_MUTEX</a>
<a name="l00141"></a>00141             <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a> = <span class="keyword">new</span> <span class="keywordtype">unsigned</span> int(1);
<a name="l00142"></a>00142             <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a> = rep;
<a name="l00143"></a>00143         }
<a name="l00144"></a>00144 
<a name="l00145"></a><a class="code" href="classOgre_1_1SharedPtr.html#cd2b97578b72dd4abc33471a93ca4b91">00145</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SharedPtr.html#cd2b97578b72dd4abc33471a93ca4b91">unique</a>()<span class="keyword"> const </span>{ <a class="code" href="OgrePrerequisites_8h.html#062b6df8793a5440c06a9056ff1c8fe9">OGRE_LOCK_AUTO_SHARED_MUTEX</a> assert(<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>); <span class="keywordflow">return</span> *<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a> == 1; }
<a name="l00146"></a><a class="code" href="classOgre_1_1SharedPtr.html#29e90ed7b4339cce1cc7e6be919e78bb">00146</a>         <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1SharedPtr.html#29e90ed7b4339cce1cc7e6be919e78bb">useCount</a>()<span class="keyword"> const </span>{ <a class="code" href="OgrePrerequisites_8h.html#062b6df8793a5440c06a9056ff1c8fe9">OGRE_LOCK_AUTO_SHARED_MUTEX</a> assert(<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>); <span class="keywordflow">return</span> *<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>; }
<a name="l00147"></a><a class="code" href="classOgre_1_1SharedPtr.html#21c3410c03ec3a4647c7aaa8e59d535d">00147</a>         <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* <a class="code" href="classOgre_1_1SharedPtr.html#21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>; }
<a name="l00148"></a>00148 
<a name="l00149"></a><a class="code" href="classOgre_1_1SharedPtr.html#15e055008751a7c20bdde38662d5f0a1">00149</a>         <span class="keyword">inline</span> T* <a class="code" href="classOgre_1_1SharedPtr.html#15e055008751a7c20bdde38662d5f0a1">getPointer</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>; }
<a name="l00150"></a>00150 
<a name="l00151"></a><a class="code" href="classOgre_1_1SharedPtr.html#8a223db784efd7aa766792649de2f2a0">00151</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SharedPtr.html#8a223db784efd7aa766792649de2f2a0">isNull</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a> == 0; }
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="classOgre_1_1SharedPtr.html#e23c79e49621afdb17fc32f30519859f">00153</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#e23c79e49621afdb17fc32f30519859f">setNull</a>(<span class="keywordtype">void</span>) { 
<a name="l00154"></a>00154             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>)
<a name="l00155"></a>00155             {
<a name="l00156"></a>00156                 <span class="comment">// can't scope lock mutex before release incase deleted</span>
<a name="l00157"></a>00157                 <a class="code" href="classOgre_1_1SharedPtr.html#a9225d4dac90501b6a5f0b2b49ea2eed">release</a>();
<a name="l00158"></a>00158                 <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a> = 0;
<a name="l00159"></a>00159                 <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a> = 0;
<a name="l00160"></a>00160             }
<a name="l00161"></a>00161         }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163     <span class="keyword">protected</span>:
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="classOgre_1_1SharedPtr.html#a9225d4dac90501b6a5f0b2b49ea2eed">00165</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#a9225d4dac90501b6a5f0b2b49ea2eed">release</a>(<span class="keywordtype">void</span>)
<a name="l00166"></a>00166         {
<a name="l00167"></a>00167             <span class="keywordtype">bool</span> destroyThis = <span class="keyword">false</span>;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169             <span class="comment">/* If the mutex is not initialized to a non-zero value, then</span>
<a name="l00170"></a>00170 <span class="comment">               neither is pUseCount nor pRep.</span>
<a name="l00171"></a>00171 <span class="comment">             */</span>
<a name="l00172"></a>00172 
<a name="l00173"></a>00173             <a class="code" href="OgrePrerequisites_8h.html#2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(<a class="code" href="OgrePrerequisites_8h.html#b5230fc97085f9d074db2e47a4fd93d4">OGRE_AUTO_MUTEX_NAME</a>)
<a name="l00174"></a>00174             {
<a name="l00175"></a>00175                 <span class="comment">// lock own mutex in limited scope (must unlock before destroy)</span>
<a name="l00176"></a>00176                 <a class="code" href="OgrePrerequisites_8h.html#062b6df8793a5440c06a9056ff1c8fe9">OGRE_LOCK_AUTO_SHARED_MUTEX</a>
<a name="l00177"></a>00177                 <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>)
<a name="l00178"></a>00178                 {
<a name="l00179"></a>00179                     <span class="keywordflow">if</span> (--(*<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>) == 0) 
<a name="l00180"></a>00180                     {
<a name="l00181"></a>00181                         destroyThis = <span class="keyword">true</span>;
<a name="l00182"></a>00182                     }
<a name="l00183"></a>00183                 }
<a name="l00184"></a>00184             }
<a name="l00185"></a>00185             <span class="keywordflow">if</span> (destroyThis)
<a name="l00186"></a>00186                 <a class="code" href="classOgre_1_1SharedPtr.html#faba3332d99634ccbacef674fc46b773">destroy</a>();
<a name="l00187"></a>00187 
<a name="l00188"></a>00188             <a class="code" href="OgrePrerequisites_8h.html#053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00189"></a>00189         }
<a name="l00190"></a>00190 
<a name="l00191"></a><a class="code" href="classOgre_1_1SharedPtr.html#faba3332d99634ccbacef674fc46b773">00191</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#faba3332d99634ccbacef674fc46b773">destroy</a>(<span class="keywordtype">void</span>)
<a name="l00192"></a>00192         {
<a name="l00193"></a>00193             <span class="comment">// IF YOU GET A CRASH HERE, YOU FORGOT TO FREE UP POINTERS</span>
<a name="l00194"></a>00194             <span class="comment">// BEFORE SHUTTING OGRE DOWN</span>
<a name="l00195"></a>00195             <span class="comment">// Use setNull() before shutdown or make sure your pointer goes</span>
<a name="l00196"></a>00196             <span class="comment">// out of scope before OGRE shuts down to avoid this.</span>
<a name="l00197"></a>00197             <span class="keyword">delete</span> <a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>;
<a name="l00198"></a>00198             <span class="keyword">delete</span> <a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>;
<a name="l00199"></a>00199             <a class="code" href="OgrePrerequisites_8h.html#8b873e0e48fc343f9553e1dc526ff6f3">OGRE_DELETE_AUTO_SHARED_MUTEX</a>
<a name="l00200"></a>00200         }
<a name="l00201"></a>00201 
<a name="l00202"></a><a class="code" href="classOgre_1_1SharedPtr.html#f07cad7e719e517472410d87f4e974ea">00202</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#f07cad7e719e517472410d87f4e974ea">swap</a>(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;T&gt;</a> &amp;other) 
<a name="l00203"></a>00203         {
<a name="l00204"></a>00204             std::swap(<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>, other.<a class="code" href="classOgre_1_1SharedPtr.html#8a5094cabd90223647525fe162e94e57">pRep</a>);
<a name="l00205"></a>00205             std::swap(<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>, other.<a class="code" href="classOgre_1_1SharedPtr.html#52f9915e259723090662cca7c3c51d52">pUseCount</a>);
<a name="l00206"></a>00206 <span class="preprocessor">#if OGRE_THREAD_SUPPORT</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>            std::swap(<a class="code" href="OgrePrerequisites_8h.html#b5230fc97085f9d074db2e47a4fd93d4">OGRE_AUTO_MUTEX_NAME</a>, other.OGRE_AUTO_MUTEX_NAME);
<a name="l00208"></a>00208 <span class="preprocessor">#endif</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>        }
<a name="l00210"></a>00210     };
<a name="l00211"></a>00211 
<a name="l00212"></a><a class="code" href="namespaceOgre.html#75affbcda72315c45b832f16861c4fdf">00212</a>     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T, <span class="keyword">class</span> U&gt; <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#b426b0250db523190d60f4bfe0414499">operator==</a>(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;T&gt;</a> <span class="keyword">const</span>&amp; a, <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;U&gt;</a> <span class="keyword">const</span>&amp; b)
<a name="l00213"></a>00213     {
<a name="l00214"></a>00214         <span class="keywordflow">return</span> a.<a class="code" href="classOgre_1_1SharedPtr.html#2c3ed4a7b5574c4e53adec450fd537b0">get</a>() == b.<a class="code" href="classOgre_1_1SharedPtr.html#2c3ed4a7b5574c4e53adec450fd537b0">get</a>();
<a name="l00215"></a>00215     }
<a name="l00216"></a>00216 
<a name="l00217"></a><a class="code" href="namespaceOgre.html#222b34dc505c878f7f0a66940c1c3969">00217</a>     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T, <span class="keyword">class</span> U&gt; <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#9d8174300d9fd7b766d727c85e11a20f">operator!=</a>(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;T&gt;</a> <span class="keyword">const</span>&amp; a, <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;U&gt;</a> <span class="keyword">const</span>&amp; b)
<a name="l00218"></a>00218     {
<a name="l00219"></a>00219         <span class="keywordflow">return</span> a.<a class="code" href="classOgre_1_1SharedPtr.html#2c3ed4a7b5574c4e53adec450fd537b0">get</a>() != b.<a class="code" href="classOgre_1_1SharedPtr.html#2c3ed4a7b5574c4e53adec450fd537b0">get</a>();
<a name="l00220"></a>00220     }
<a name="l00221"></a>00221 }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
